#include <stdarg.h> 
#include <string.h> 
#include <x86.h> 
#include <_printf.h> 

unsigned short* const VIDMEM = (unsigned short*) 0xB8000;

void putch(unsigned c);
void init_video(void);
void clear( void );
void gdt_init();
void idt_init();
void pic_init();
void timer_init();
void keyboard_init ();
void print_time ();


void clear( void )
{
    unsigned short* vp = VIDMEM;
    int i=0;
    for (i = 0; i < 80 * 25; i++)
    {
        *vp++ = 0;
    }
}

static int kprintf_help(unsigned c, void **ptr)
{
	putch(c);
	return 0;
}

void kprintf(const char *fmt, ...)
{
	va_list args;
	va_start(args, fmt);
	(void)do_printf(fmt, args, kprintf_help, NULL);
	va_end(args);
}

int main(void)
{

	clear();
	init_video();
	kprintf(" Stupid Os \n");

	gdt_init();
	idt_init();
	pic_init();
	keyboard_init ();
	timer_init();
	kprintf("\n www.iakovlev.org 26.03.2006\n\n");
	print_time ();

	while(1);

	return 0;
}
